searchNodes=[{"doc":"Make sure your storybook local dependency has all its assets packaged in priv. $&gt; mix dev.storybook","ref":"Mix.Tasks.Dev.Storybook.html","title":"Mix.Tasks.Dev.Storybook","type":"task"},{"doc":"Generates a Storybook and provides setup instructions. $&gt; mix phx.gen.storybook The generated files will contain: a storybook backend in lib/my_app_web/storybook.ex a custom js file in assets/js/storybook.js a custom css file in assets/css/storybook.css scaffolding including example stories for your own storybook in storybook/ The generator supports the --no-tailwind flag if you want to skip the TailwindCSS specific bit.","ref":"Mix.Tasks.Phx.Gen.Storybook.html","title":"Mix.Tasks.Phx.Gen.Storybook","type":"task"},{"doc":"PhoenixStorybook provides a storybook-like UI interface for your Phoenix components. Explore all your components, and showcase them with different variations. Browse your component's documentation, with their supported attributes. Learn how components behave by using an interactive playground. How does it work? PhoenixStorybook is mounted in your application router and serves its UI at the mounting point of your choice. It performs automatic discovery of your storybook content under a specified folder ( :content_path ) and then automatically generates a storybook navigation sidebar. Every module detected in your content folder will be loaded and identified as a storybook entry. Three kinds of stories are supported: component to describe your stateless function components or your live_components. page to write &amp; document UI guidelines, or whatever content you want. example to show how your components can be used and mixed in real UI pages. Installation To start using PhoenixStorybook in your phoenix application you will need to follow these steps: Add the phoenix_storybook dependency Run the generator 1. Add the phoenix_storybook dependency Add the following to your mix.exs and run mix deps.get: def deps do [ { :phoenix_storybook , &quot;~&gt; 0.5.0&quot; } ] end Note When picking a github version of the library (instead of an official hex.pm release) you need the get the storybook's assets compiled. To do so, please run mix dev.storybook . 2. Run the generator Run from the root of your application: $&gt; mix deps.get $&gt; mix phx.gen.storybook And you are ready to go! ℹ️ If you prefer manual setup, please read the setup guide . Configuration Of all config settings, only the :otp_app , and :content_path keys are mandatory. # lib/my_app_web/storybook.ex defmodule MyAppWeb.Storybook do use PhoenixStorybook , # OTP name of your application. otp_app : :my_app , # Path to your storybook stories (required). content_path : Path . expand ( &quot;../storybook&quot; , __DIR__ ) , # Path to your JS asset, which will be loaded just before PhoenixStorybook&#39;s own # JS. It&#39;s mainly intended to define your LiveView Hooks in `window.storybook.Hooks`. # Remote path (not local file-system path) which means this file should be served # by your own application endpoint. js_path : &quot;/assets/storybook.js&quot; , # Path to your components stylesheet. # Remote path (not local file-system path) which means this file should be served # by your own application endpoint. css_path : &quot;/assets/storybook.css&quot; , # This CSS class will be put on storybook container elements where your own styles should # prevail. See the `guides/sandboxing.md` guide for more details. sandbox_class : &quot;my-app-sandbox&quot; , # Custom storybook title. Default is &quot;Live Storybook&quot;. title : &quot;My Live Storybook&quot; , # Theme settings. # Each theme must have a name, and an optional dropdown_class. # When set, a dropdown is displayed in storybook header to let the user pick a theme. # The dropdown_class is used to render the theme in the dropdown and identify which current # theme is active. # # The chosen theme key will be passed as an assign to all components. # ex: &lt;.component theme={:colorful}/&gt; # # The chosen theme class will also be added to the `.lsb-sandbox` container. # ex: &lt;div class=&quot;lsb-sandbox theme-colorful&quot;&gt;...&lt;/div&gt; # # If no theme has been selected or if no theme is present in the URL the first one is enabled. themes : [ default : [ name : &quot;Default&quot; ] , colorful : [ name : &quot;Colorful&quot; , dropdown_class : &quot;text-pink-400&quot; ] # If you want to use custom FontAwesome icons. font_awesome_plan : :pro , # default value is :free font_awesome_kit_id : &quot;foo8b41bar4625&quot; , # Story compilation mode, can be either `:eager` or `:lazy`. # It defaults to `:lazy` in dev environment, `:eager` in other environments. # - When eager: all .story.exs &amp; .index.exs files are compiled upfront. # - When lazy: ony .index.exs files are compiled upfront and .story.exs are compile when the # matching story is loaded in UI. compilation_mode : :eager ] All settings can be overridden from your config files. # config/config.exs config :my_app , MyAppWeb.Storybook , content_path : &quot;overridden/content/path&quot; ℹ️ Learn more on theming components in the theming guide , on icons in the icons guide.","ref":"PhoenixStorybook.html","title":"PhoenixStorybook","type":"module"},{"doc":"Behaviour implemented by your backend module.","ref":"PhoenixStorybook.BackendBehaviour.html","title":"PhoenixStorybook.BackendBehaviour","type":"behaviour"},{"doc":"Returns a configuration value from your config.exs storybook settings. key is the config key default is an optional default value if no value can be fetched.","ref":"PhoenixStorybook.BackendBehaviour.html#c:config/2","title":"PhoenixStorybook.BackendBehaviour.config/2","type":"callback"},{"doc":"Returns a precompiled tree of your storybook stories.","ref":"PhoenixStorybook.BackendBehaviour.html#c:content_tree/0","title":"PhoenixStorybook.BackendBehaviour.content_tree/0","type":"callback"},{"doc":"Returns an entry from its absolute storybook path (not filesystem).","ref":"PhoenixStorybook.BackendBehaviour.html#c:find_entry_by_path/1","title":"PhoenixStorybook.BackendBehaviour.find_entry_by_path/1","type":"callback"},{"doc":"Returns all the nodes (stoires &amp; folders) of the storybook content tree as a flat list.","ref":"PhoenixStorybook.BackendBehaviour.html#c:flat_list/0","title":"PhoenixStorybook.BackendBehaviour.flat_list/0","type":"callback"},{"doc":"Returns all the leaves (only stories) of the storybook content tree.","ref":"PhoenixStorybook.BackendBehaviour.html#c:leaves/0","title":"PhoenixStorybook.BackendBehaviour.leaves/0","type":"callback"},{"doc":"Retuns a storybook path from a story module.","ref":"PhoenixStorybook.BackendBehaviour.html#c:storybook_path/1","title":"PhoenixStorybook.BackendBehaviour.storybook_path/1","type":"callback"},{"doc":"This module is meant to be used from generated welcome.story.exs page. It renders HTML markup from markdown guides located in the guides/folder. Markup is precompiled because: we don't want to force user application to embed Earmark we don't wont to put markdown guides in priv Examples Guides . markup ( &quot;components.md&quot; ) Guides . markup ( &quot;icons.md&quot; )","ref":"PhoenixStorybook.Guides.html","title":"PhoenixStorybook.Guides","type":"module"},{"doc":"","ref":"PhoenixStorybook.Guides.html#markup/1","title":"PhoenixStorybook.Guides.markup/1","type":"function"},{"doc":"An index is an optional file you can create in every folder of your storybook content tree to improve rendering of the storybook sidebar. The index files can be used: to customize the folder itself: name, icon and opening status. to customize folder direct children (only stories): name and icon. Indexes must be created as index.exs files. Read the icons guide for more information on custom icon usage. Usage # storybook/_components.index.exs defmodule MyAppWeb.Storybook.Components do use PhoenixStorybook.Index def folder_name , do : &quot;My Components&quot; def folder_icon , do : { :fa , &quot;icon&quot; } def folder_open? , do : true def entry ( &quot;a_component&quot; ) , do : [ name : &quot;My Component&quot; ] def entry ( &quot;other_component&quot; ) , do : [ name : &quot;Another Component&quot; , icon : { :fa , &quot;icon&quot; , :thin } ] end","ref":"PhoenixStorybook.Index.html","title":"PhoenixStorybook.Index","type":"module"},{"doc":"Convenience helper for using the functions above.","ref":"PhoenixStorybook.Index.html#__using__/1","title":"PhoenixStorybook.Index.__using__/1","type":"macro"},{"doc":"Responsible for rendering your components code snippet, for a given PhoenixStorybook.Variation . Uses the Makeup libray for syntax highlighting.","ref":"PhoenixStorybook.Rendering.CodeRenderer.html","title":"PhoenixStorybook.Rendering.CodeRenderer","type":"module"},{"doc":"Renders a component code snippet from a RenderingContext . Returns a Phoenix.LiveView.Rendered .","ref":"PhoenixStorybook.Rendering.CodeRenderer.html#render/1","title":"PhoenixStorybook.Rendering.CodeRenderer.render/1","type":"function"},{"doc":"","ref":"PhoenixStorybook.Rendering.CodeRenderer.html#render/2","title":"PhoenixStorybook.Rendering.CodeRenderer.render/2","type":"function"},{"doc":"Renders source of a component story. Returns a rendered HEEx template.","ref":"PhoenixStorybook.Rendering.CodeRenderer.html#render_component_source/1","title":"PhoenixStorybook.Rendering.CodeRenderer.render_component_source/1","type":"function"},{"doc":"","ref":"PhoenixStorybook.Rendering.CodeRenderer.html#render_source/2","title":"PhoenixStorybook.Rendering.CodeRenderer.render_source/2","type":"function"},{"doc":"Responsible for rendering your function &amp; live components.","ref":"PhoenixStorybook.Rendering.ComponentRenderer.html","title":"PhoenixStorybook.Rendering.ComponentRenderer","type":"module"},{"doc":"Renders a component from a RenderingContext . Returns a Phoenix.LiveView.Rendered .","ref":"PhoenixStorybook.Rendering.ComponentRenderer.html#render/1","title":"PhoenixStorybook.Rendering.ComponentRenderer.render/1","type":"function"},{"doc":"","ref":"PhoenixStorybook.Rendering.ComponentRenderer.html#render/2","title":"PhoenixStorybook.Rendering.ComponentRenderer.render/2","type":"function"},{"doc":"A struct holding all data needed by ComponentRenderer and CodeRenderer to render story variations.","ref":"PhoenixStorybook.Rendering.RenderingContext.html","title":"PhoenixStorybook.Rendering.RenderingContext","type":"module"},{"doc":"","ref":"PhoenixStorybook.Rendering.RenderingContext.html#build/4","title":"PhoenixStorybook.Rendering.RenderingContext.build/4","type":"function"},{"doc":"Provides LiveView routing for storybook.","ref":"PhoenixStorybook.Router.html","title":"PhoenixStorybook.Router","type":"module"},{"doc":"Defines a PhoenixStorybook route. It expects the path the storybook will be mounted at and a set of options. This will also generate a named helper called live_storybook_path/2 which you can use to link directly to the storybook, such as: &lt; . link href = { live_storybook_path ( conn , :root ) } / &gt; Note that you should only use the href attribute to link to the storybook, as it has to set its own session on first rendering. Linking with patch or navigate will not work. Options :backend_module - Required - Name of your backend module. :live_socket_path - Configures the socket path. It must match the socket &quot;/live&quot;, Phoenix.LiveView.Socket in your endpoint. :assets_path - Configures the assets path. It must match the storybook_assets in your router. Defaults to &quot;/storybook/assets&quot; . :session_name - Configures the live session name. Defaults to :live_storybook . Use this option if you want to mount multiple storybooks in the same router. :as - Allows you to set the route helper name. Defaults to :live_storybook . :pipeline - Set to false if you don't want a router pipeline to be created. This is useful if you want to define your own :storybook_browser pipeline, or if you mount multiple storybooks, in which case the pipeline only has to be defined once. Defaults to true . Usage # lib/my_app_web/router.ex use MyAppWeb , :router import PhoenixStorybook.Router ... scope &quot;/&quot; do pipe_through :browser live_storybook &quot;/storybook&quot; , backend_module : MyAppWeb.Storybook end Note that it is not possible to use this macro in a scope with a path different from / .","ref":"PhoenixStorybook.Router.html#live_storybook/2","title":"PhoenixStorybook.Router.live_storybook/2","type":"macro"},{"doc":"Defines routes for PhoenixStorybook static assets. Static assets should not be CSRF protected. So they need to be mounted in your router in a different pipeline than storybook's. It can take the path the storybook assets will be mounted at. Default path is &quot;/storybook/assets&quot; . Usage # lib/my_app_web/router.ex use MyAppWeb , :router import PhoenixStorybook.Router ... scope &quot;/&quot; do storybook_assets ( ) end","ref":"PhoenixStorybook.Router.html#storybook_assets/1","title":"PhoenixStorybook.Router.storybook_assets/1","type":"macro"},{"doc":"An attr is one of your component attributes. Its structure mimics the LiveView 0.18.0 declarative assigns. Attributes declaration will populate the Playground tab of your storybook, for each of your components.","ref":"PhoenixStorybook.Stories.Attr.html","title":"PhoenixStorybook.Stories.Attr","type":"module"},{"doc":"id : the attribute id (required). Should match your component assign. type : the attribute type (required). Must be one of: :any - any term :string - any binary string :atom - any atom :boolean - any boolean :integer - any integer :float - any float :map - any map :list - a List of any arbitrary types :global - any common HTML attributes, Any struct module required : true if the attribute is mandatory. default : attribute default value. examples the list or range of examples suggested for the attribute values the list or range of all possible examples for the attribute. Unlike examples, this option enforces validation of the default value against the given list. doc : a text documentation for this attribute.","ref":"PhoenixStorybook.Stories.Attr.html#t:t/0","title":"PhoenixStorybook.Stories.Attr.t/0","type":"type"},{"doc":"Functions to fetch component documentation and render it at HTML.","ref":"PhoenixStorybook.Stories.Doc.html","title":"PhoenixStorybook.Stories.Doc","type":"module"},{"doc":"Fetch component documentation from component source and format it as HTML. For a live_component, fetches @moduledoc content For a function component, fetches @doc content of the relevant function Output HTML is splitted in paragraphs and returned as a list of paragraphs.","ref":"PhoenixStorybook.Stories.Doc.html#fetch_doc_as_html/1","title":"PhoenixStorybook.Stories.Doc.fetch_doc_as_html/1","type":"function"},{"doc":"A slot is one of your component slots. Its structure mimics the LiveView 0.18.0 declarative assigns. Slots declaration will populate the Playground tab of your storybook, for each of your components. Supported keys: id : the slot id (required). Should match your component slot name. Use the id :inner_block for your component default slot. doc : a text documentation for this slot. required : true if the attribute is mandatory.","ref":"PhoenixStorybook.Stories.Slot.html","title":"PhoenixStorybook.Stories.Slot","type":"module"},{"doc":"","ref":"PhoenixStorybook.Stories.Slot.html#t:t/0","title":"PhoenixStorybook.Stories.Slot.t/0","type":"type"},{"doc":"A variation captures the rendered state of a UI component. Developers write multiple variations per component that describe all the “interesting” states a component can support. Each variation will be displayed in the storybook as a code snippet alongside with the component preview. Variations attributes type are checked against their matching attribute (if any) and will raise a compilation an error in case of mismatch. Advanced component &amp; variation documentation is available in the components guide . Usage def variations do [ % Variation { id : :default , description : &quot;Default dropdown&quot; , attributes : %{ label : &quot;A dropdown&quot; , } , slots : [ ~s|&lt;:entry path=&quot;#&quot; label=&quot;Account settings&quot;/&gt;| , ~s|&lt;:entry path=&quot;#&quot; label=&quot;Support&quot;/&gt;| , ~s|&lt;:entry path=&quot;#&quot; label=&quot;License&quot;/&gt;| ] } ] end","ref":"PhoenixStorybook.Stories.Variation.html","title":"PhoenixStorybook.Stories.Variation","type":"module"},{"doc":"","ref":"PhoenixStorybook.Stories.Variation.html#t:t/0","title":"PhoenixStorybook.Stories.Variation.t/0","type":"type"},{"doc":"A variation group is a set of similar variations that will be rendered together in a single preview &lt;pre&gt; block. Usage def variations do [ % VariationGroup { id : :colors , description : &quot;Different color buttons&quot; , variations : [ % Variation { id : :blue_button , attributes : %{ label : &quot;A button&quot; , color : :blue } } , % Variation { id : :red_button , attributes : %{ label : &quot;A button&quot; , color : :red } } , % Variation { id : :green_button , attributes : %{ label : &quot;A button&quot; , color : :green } } ] } ] end","ref":"PhoenixStorybook.Stories.VariationGroup.html","title":"PhoenixStorybook.Stories.VariationGroup","type":"module"},{"doc":"","ref":"PhoenixStorybook.Stories.VariationGroup.html#t:t/0","title":"PhoenixStorybook.Stories.VariationGroup.t/0","type":"type"},{"doc":"A story designates any kind of content in your storybook. For now only following kinds of stories are supported :component , :live_component , and :page . In order to populate your storybook, just create story scripts under your content path, and implement their required behaviour. Stories must be created as story.exs files. In dev environment, stories are lazily compiled when reached from the UI. Usage Component Implement your component as such. Confer to: PhoenixStorybook.Variation documentation for variations. PhoenixStorybook.Attr documentation for attributes. # storybook/my_component.exs defmodule MyAppWeb.Storybook.MyComponent do use PhoenixStorybook.Story , :component # required def function , do : &amp; MyAppWeb.MyComponent . my_component / 1 def attributes , do : [ ] def slots , do : [ ] def variations , do : [ ] end Live Component Very similar to components, except that you need to define a component/0 function instead of function/0 . # storybook/my_live_component.exs defmodule MyAppWeb.Storybook.MyLiveComponent do use PhoenixStorybook.Story , :live_component # required def component , do : MyAppWeb.MyLiveComponent def attributes , do : [ ] def slots , do : [ ] def variations , do : [ ] end ℹ️ Learn more on components in the components guide . Page A page is a fairly simple story that can be used to write whatever content you want. We use it to provide some UI guidelines. You should implement the render function and an optional navigation function, if you want a tab based sub-navigation. Current tab is passed as :tab in render/1 assigns. # storybook/my_page.exs defmodule MyAppWeb.Storybook.MyPage do use PhoenixStorybook.Story , :page def doc , do : &quot;My page description&quot; def navigation do [ { :tab_one , &quot;Tab One&quot; , { :fa , &quot;book&quot; } } , { :tab_two , &quot;Tab Two&quot; , { :fa , &quot;cake&quot; , :solid } } ] end def render ( assigns ) do ~H&quot;&lt;div&gt;Your HEEX template&lt;/div&gt;&quot; end end Example An example is a real-world UI showcasing how your components can be used and mixed in complex UI interfaces. Examples ares rendered as a child LiveView, so you can implement mount/3 , render/1 or any handle_event/3 callback. Unfortunately handle_params/3 cannot be defined in a child LiveView. By default, your example story's source code will be shown in a dedicated tab. But you can show additional files source code by implementing the extra_sources/0 function which should return a list of relative paths to your example related files. # storybook/my_example.story.exs defmodule MyAppWeb.Storybook.MyPage do use PhoenixStorybook.Story , :example def doc , do : &quot;My page description&quot; def extra_sources do [ &quot;./template.html.heex&quot; , &quot;./my_page_html.ex&quot; ] end def mount ( _ , _ , socket ) , do : { :ok , socket } def render ( assigns ) do ~H&quot;&lt;div&gt;Your HEEX template&lt;/div&gt;&quot; end end","ref":"PhoenixStorybook.Story.html","title":"PhoenixStorybook.Story","type":"module"},{"doc":"Convenience helper for using the functions above.","ref":"PhoenixStorybook.Story.html#__using__/1","title":"PhoenixStorybook.Story.__using__/1","type":"macro"},{"doc":"Basic component documentation is in PhoenixStorybook.Story .","ref":"components.html","title":"Component stories","type":"extras"},{"doc":"Component documentation is fetched from your component doc tags: For a live_component, fetches @moduledoc content. For a function component, fetches @doc content from the matching function. If you are deploying phoenix_storybook in production with an Elixir release, make sure your doc chunks are not stripped out from the release. releases : [ my_app_web : [ strip_beams : [ keep : [ &quot;Docs&quot; ] ] ] ]","ref":"components.html#documentation","title":"Component stories - Documentation","type":"extras"},{"doc":"You may want to present different variations of a component in a single variation block. It is possible using PhoenixStorybook.VariationGroup .","ref":"components.html#variation-groups","title":"Component stories - Variation groups","type":"extras"},{"doc":"By default, each variation is rendered within a div in the storybook DOM. You can pass additional HTML attributes or extend the class attribute. # storybook/my_component.story.exs defmodule Storybook.MyComponent do use PhoenixStorybook.Story , :component def container , do : { :div , class : &quot;block&quot; } end If you need further sandboxing you can opt in for iframe rendering. # storybook/my_component.story.exs defmodule Storybook.MyComponent do use PhoenixStorybook.Story , :component def container , do : :iframe end ℹ️ Learn more on this topic in the sandboxing guide .","ref":"components.html#container","title":"Component stories - Container","type":"extras"},{"doc":"When using nested components or JS commands, you might need to reference other functions or components. Whilst it is possible to use fully qualified module names, you might want to provide custom aliases and imports . Here is an example defining both: defmodule NestedComponent do use PhoenixStorybook.Story , :component def function , do : &amp; NestedComponent . nested_component / 1 def aliases , do : [ MyStorybook.Helpers.JSHelpers ] def imports , do : [ { NestedComponent , nested : 1 } ] def variations do [ % Variation { id : :default , slots : [ &quot;&quot;&quot; &lt;.nested phx-click={JSHelpers.toggle()}&gt;hello&lt;/.nested&gt; &lt;.nested phx-click={JSHelpers.toggle()}&gt;world&lt;/.nested&gt; &quot;&quot;&quot; ] } ] end end","ref":"components.html#aliases-imports","title":"Component stories - Aliases &amp; Imports","type":"extras"},{"doc":"You may want to render your components within some wrapping markup. For instance, when your component can only be used as a slot of another enclosing component. Some components, such as modals , slideovers , and notifications , are not visible from the start: they first need user interaction. Such components can be accompanied by an outer template, that will for instance render a button next to the component, to toggle its visibility state. Variation templates You can define a template in your component story by defining a template/0 function. Every variation will be rendered within the defined template, the variation itself is injected in place of &lt;.lsb-variation/&gt; . def template do &quot;&quot;&quot; &lt;div class=&quot;my-custom-wrapper&quot;&gt; &lt;.lsb-variation/&gt; &lt;/div&gt; &quot;&quot;&quot; end You can also override the template, per variation or variation_group by setting the :template key to your variation. Setting it to a falsy value will disable templating for this variation. Variation group templates Variation groups can also leverage on templating: either by wrapping every variation in their own template. &quot;&quot;&quot; &lt;div class=&quot;one-wrapper-for-each-variation&quot;&gt; &lt;.lsb-variation/&gt; &lt;/div&gt; &quot;&quot;&quot; or by wrapping all variations as a whole, in a single template. &quot;&quot;&quot; &lt;div class=&quot;a-single-wrapper-for-all&quot;&gt; &lt;.lsb-variation-group/&gt; &lt;/div&gt; &quot;&quot;&quot; If you want to get unique id, you can use :variation_id that will be replaced, at rendering time by the current variation (or variation group) id. Placeholder attributes In template, you can pass some extra attributes to your variation. Just add them to the .lsb-variation or .lsb-variation-group placeholder. &quot;&quot;&quot; &lt;.form_for :let={f} for={%{}} as={:user}&gt; &lt;.lsb-variation form={f}/&gt; &lt;/.form&gt; &quot;&quot;&quot; JS-controlled visibility Here is an example of templated component managing its visibility client-side, by toggling CSS classes through JS commands . defmodule Storybook.Components.Modal do use PhoenixStorybook.Story , :component def function , do : &amp; Components.Modal . modal / 1 def template do &quot;&quot;&quot; &lt;div&gt; &lt;button phx-click={Modal.show_modal()}&gt;Open modal&lt;/button&gt; &lt;.lsb-variation/&gt; &lt;/div&gt; &quot;&quot;&quot; end def variations do [ % Variation { id : :default_modal , slots : [ &quot;&lt;:body&gt;hello world&lt;/:body&gt;&quot; ] } ] end end Elixir-controlled visibility Some components don't rely on JS commands but need external assigns, like a modal that takes a show={true} or show={false} assign to manage its visibility state. PhoenixStorybook handles special assign and toggle events that you can leverage on to update some properties that will be passed to your components as extra assigns . defmodule Storybook.Components.Slideover do use PhoenixStorybook.Story , :component def function , do : &amp; Components.Slideover . slideover / 1 def template do &quot;&quot;&quot; &lt;div&gt; &lt;button phx-click={JS.push(&quot;assign&quot;, value: %{show: true})}&gt; Open slideover &lt;/button&gt; &lt;.lsb-variation/&gt; &lt;/div&gt; &quot;&quot;&quot; end def variations do [ % Variation { id : :default_slideover , attributes : %{ close_event : JS . push ( &quot;assign&quot; , value : %{ variation_id : :default_slideover , show : false } ) } , slots : [ &quot;&lt;:body&gt;Hello world&lt;/:body&gt;&quot; ] } ] end end Template code preview By default, the code preview will render the variation and its template markup as well. You can choose to render only the variation markup, without its surrounding template by using the lsb-code-hidden HTML attribute. &quot;&quot;&quot; &lt;div lsb-code-hidden&gt; &lt;button phx-click={Modal.show_modal()}&gt;Open modal&lt;/button&gt; &lt;.lsb-variation/&gt; &lt;/div&gt; &quot;&quot;&quot;","ref":"components.html#templates","title":"Component stories - Templates","type":"extras"},{"doc":"Liveview let you define blocks of HEEx content in your components, referred to as as slots. They can be passed in your variations with the :slots keys : % Variation { id : :modal , slots : [ &quot;&quot;&quot; &lt;:button&gt; &lt;button type=&quot;button&quot;&gt;Cancel&lt;/button&gt; &lt;/:button&gt; &quot;&quot;&quot; , &quot;&quot;&quot; &lt;:button&gt; &lt;button type=&quot;button&quot;&gt;OK&lt;/button&gt; &lt;/:button&gt; &quot;&quot;&quot; ] } You can also use LiveView let mechanism to pass data to your default block. You just need to declare the let attribute you are using in your variation. % Variation { id : :list , attributes : %{ stories : ~w(apple banana cherry) } , let : :entry , slots : [ &quot;I like &lt;%= entry %&gt;&quot; ] } let syntax can also be used with named slots, but requires no specific livebook setup. % Variation { id : :table , attributes : %{ rows : [ %{ first_name : &quot;Jean&quot; , last_name : &quot;Dupont&quot; } , %{ first_name : &quot;Sam&quot; , last_name : &quot;Smith&quot; } ] } , slots : [ &quot;&quot;&quot; &lt;:col :let={user} label=&quot;First name&quot;&gt; &lt;%= user.first_name %&gt; &lt;/:col&gt; &quot;&quot;&quot; , &quot;&quot;&quot; &lt;:col :let={user} label=&quot;Last name&quot;&gt; &lt;%= user.last_name %&gt; &lt;/:col&gt; &quot;&quot;&quot; ] }","ref":"components.html#block-slots-let","title":"Component stories - Block, slots &amp; let","type":"extras"},{"doc":"In some cases, you want to pass to your variation attributes a complex value which should be evaluated at runtime but not in code preview (where you rather want to see the orignal expression). For instance with the following variation of a Modal component. % Variation { attributes : %{ :&quot;on-open&quot; : JS . push ( &quot;open&quot; ) , :&quot;on-close&quot; : { :eval , ~s|JS.push(&quot;close&quot;)| } } } Both open &amp; close events would work, but code would be rendered like this. &lt; . modal on - open = &quot;%Phoenix.LiveView.JS{ops: [[&quot; push &quot;, %{event: &quot; open &quot;}]]}&quot; on - close = { JS . push ( &quot;close&quot; ) } / &gt;","ref":"components.html#late-evaluation","title":"Component stories - Late evaluation","type":"extras"},{"doc":"You can provide custom sidebar &amp; header icons for your stories. Page stories can also provide iconized navigation tabs. PhoenixStorybook gives you the ability to render icons with 2 different providers: FontAwesome which offers a decent set of free icons and a lot of additional styles with paid plans HeroIcons wich offer hundreds of free high quality icons","ref":"icons.html","title":"Custom Icons","type":"extras"},{"doc":"Whenever you provide an icon to the storybook, you should follow the following structure: {:icon_provider, icon_name, :icon_style, additional_css_classes} . The two last tuple elements are optional. { :fa , &quot;book&quot; } # note that the FontAwesome icon name omits the fa- prefix { :fa , &quot;book&quot; , :solid } # same than previous one, :solid is the default style { :fa , &quot;skull&quot; , :duotone } # only for FontAwesome paid users { :fa , &quot;skull&quot; , :duotone , &quot;lsb-px-2&quot; } { :hero , &quot;cake&quot; } # for all HeroIcons { :hero , &quot;cake&quot; , :outline } # same than previous one, :outline is the default style { :hero , &quot;cake&quot; , :outline , &quot;lsb-w-2 lsb-h-2&quot; }","ref":"icons.html#declaring-an-icon","title":"Custom Icons - Declaring an icon","type":"extras"},{"doc":"PhoenixStorybook is built with a very small subset of FontAwesome free icons. If you want to use other FontAwesome icons you need to provide a valid FontAwesome kit id . It can be either free or paid, so you also need to configure your FontAwesome plan. # lib/my_app_web/storybook.ex defmodule MyAppWeb.Storybook do use PhoenixStorybook , otp_app : :my_app , font_awesome_plan : :pro , # default value is :free font_awesome_kit_id : &quot;foo8b41bar4625&quot; , end","ref":"icons.html#fontawesome-icons","title":"Custom Icons - FontAwesome icons","type":"extras"},{"doc":"PhoenixStorybook delegates icon rendering to heroicons_elixir . Make sure to add their dependency in your mix.exs file. defp deps do [ { :heroicons , &quot;~&gt; 0.5.0&quot; } ] end You can now use whichever HeroIcon icon you want, based on the library function names.","ref":"icons.html#heroicons","title":"Custom Icons - HeroIcons","type":"extras"},{"doc":"The last tuple argument is an optional CSS class list you can pass to improve icon rendering. Since the icon is rendered within the storybook layout, and not within your components sandbox, you should use CSS classes supported by the storybook. any lsb-w-* or lsb-h-* class (TailwindCSS classes for height &amp; width prefixed by lsb- ) any lsb-p-* or lsb-m-* class (padding &amp; margin) any lsb-text-color-### any fa-* (FontAwesome modifiers)","ref":"icons.html#custom-css","title":"Custom Icons - Custom CSS","type":"extras"},{"doc":"In PhoenixStorybook your components live within the storybook, so they share some context with the storybook: styling and scripts . While the original Storybook for React only relies on iframes , we find them quite slow and don't want them to be the default choice. This guide will explain: what JS context do your components share with the storybook? how is the storybook styled to prevent most styling clashes? how you should provide the style of your components with scoped styles. how to, as a last resort, enable iframe rendering.","ref":"sandboxing.html","title":"Sandboxing components","type":"extras"},{"doc":"PhoenixStorybook runs with Phoenix LiveView and therefore requires its LiveSocket . This LiveSocket is the same used by your components: you just need to inject it with your own Hooks , Params and Uploaders . To do so, create a JS file that will declare your Hooks , Params and Uploaders and set them in window.storybook . This script will be loaded immediately before the storybook's script. :information_source: If you used mix phx.gen.storybook this file has already been created for you. // assets/js/storybook.js import * as Hooks from &quot;./hooks&quot;; import * as Params from &quot;./params&quot;; import * as Uploaders from &quot;./uploaders&quot;; (function () { window.storybook = { Hooks, Params, Uploaders }; })(); Then set the js_path: &quot;/assets/storybook.js&quot; option to the storybook within your storybook.ex file. This is a remote path (not a local file-system path) which means this file should be served by your own application endpoint with the given path. You can also use this script to inject whatever content you want into document HEAD , such as external scripts. The Params will be available in page stories as connect_params assign. There is currently no way to access them in component or live component stories.","ref":"sandboxing.html#1-what-js-context-do-your-components-share-with-the-storybook","title":"Sandboxing components - 1. What JS context do your components share with the storybook?","type":"extras"},{"doc":"PhoenixStorybook is using TailwindCSS with preflight (which means all default HTML styles from your browser are removed) and a custom prefix : lsb- (which means that instead of using bg-blue-400 the storybook uses lsb-bg-blue-400 ). Only elements with the .lsb class are preflighted, in order to let your component styling as-is. So unless your components use lsb or lsb- prefixed classes there should be no styling leak from the storybook to you components.","ref":"sandboxing.html#2-how-is-the-storybook-styled","title":"Sandboxing components - 2. How is the storybook styled?","type":"extras"},{"doc":"You need to inject your component's stylesheets into the storybook. Set the css_path: &quot;/assets/storybook.css&quot; option in storybook.ex . This is a remote path (not a local file-system path) which means this file should be served by your own application endpoint with the given path. The previous part (2.) was about storybook styles not leaking into your components. This part is about the opposite: don't accidentally mess up Storybook styling with your styles. All containers rendering your components in the storybook ( stories , playground , pages ...) carry the .lsb-sandbox CSS class and a custom sandboxing class of your choice . You can leverage this to scope your styles with this class. Here is how you can do it with TailwindCSS : configure phoenix_storybook with a custom sandbox_class : # lib/my_app_web/storybook.ex defmodule MyAppWeb.Storybook do use PhoenixStorybook , ... sandbox_class : &quot;my-app-sandbox&quot; , use Tailwind important selector strategy with this class. It will prefix all your tailwind classes increasing their specificity, hence their priority. // assets/tailwind.config.js module.exports = { // ... important: &quot;.my-app-sandbox&quot;, }; nest your custom styles under Tailwind @layer utilities . This way, your styling will also benefit from sandboxing. /* assets/css/storybook.css */ @tailwind base; @tailwind components; @tailwind utilities; @layer utilities { /* this style will be generated as .my-app-sandbox * { ... } */ * { font-family: &quot;MyComponentsFont&quot;; @apply text-slate-600; } /* this style will be generated as .my-app-sandbox h1 { ... } */ h1 { @apply text-2xl font-bold text-slate-700 mt-2 mb-6; } /* this style will be generated as .my-app-sandbox h2 { ... } */ h2 { @apply text-xl font-bold text-slate-700 mt-2 mb-4; } }","ref":"sandboxing.html#3-how-should-you-provide-the-style-of-your-components","title":"Sandboxing components - 3. How should you provide the style of your components?","type":"extras"},{"doc":"As a last resort, if for whatever reason you cannot make your component live within the storybook, it is possible to enable iframe rendering, component per component. This could be required e.g. if you need to bind listeners on document or when you want to make sure responsive css works as expected. Just add the iframe option to it. # storybook/components/button.exs defmodule MyAppWeb.Storybook.Components.Button do alias MyAppWeb.Components.Button use PhoenixStorybook.Story , :component def function , do : &amp; Button . button / 1 def container , do : :iframe # ... end","ref":"sandboxing.html#4-enabling-iframe-rendering","title":"Sandboxing components - 4. Enabling iframe rendering","type":"extras"},{"doc":"To start using PhoenixStorybook in your phoenix application you will need to follow these steps: Add the phoenix_storybook dependency Create your storybook backend module Add storybook access to your router Make your components assets available Create some content","ref":"setup.html","title":"Manual setup","type":"extras"},{"doc":"Add the following to your mix.exs and run mix deps.get: def deps do [ { :phoenix_storybook , &quot;~&gt; 0.5.0&quot; } ] end","ref":"setup.html#1-add-the-phoenix_storybook-dependency","title":"Manual setup - 1. Add the phoenix_storybook dependency","type":"extras"},{"doc":"Create a new module under your application lib folder: # lib/my_app_web/storybook.ex defmodule MyAppWeb.Storybook do use PhoenixStorybook , otp_app : :my_app , content_path : Path . expand ( &quot;../storybook&quot; , __DIR__ ) , # assets path are remote path, not local file-system paths css_path : &quot;/assets/my_components.css&quot; , js_path : &quot;/assets/my_components.js&quot; end","ref":"setup.html#2-create-your-storybook-backend-module","title":"Manual setup - 2. Create your storybook backend module","type":"extras"},{"doc":"Once installed, update your router's configuration to forward requests to a PhoenixStorybook with a unique name of your choice: # lib/my_app_web/router.ex use MyAppWeb , :router import PhoenixStorybook.Router ... scope &quot;/&quot; do storybook_assets ( ) end scope &quot;/&quot; , PhoenixStorybookSampleWeb do pipe_through ( :browser ) ... live_storybook &quot;/storybook&quot; , backend_module : MyAppWeb.Storybook end","ref":"setup.html#3-add-storybook-access-to-your-router","title":"Manual setup - 3. Add storybook access to your router","type":"extras"},{"doc":"Build a new CSS bundle dedicated to your live_view components: this bundle will be used both by your app and the storybook. In this README, we use assets/css/storybook.css as an example. If your components require any hooks or custom uploaders, or if your pages require connect parameters, declare them as such in a new JS bundle: // assets/js/storybook.js import * as Hooks from &quot;./hooks&quot;; import * as Params from &quot;./params&quot;; import * as Uploaders from &quot;./uploaders&quot;; (function () { window.storybook = { Hooks, Params, Uploaders }; })(); These assets must be bundled and served by your own application. Our custom mix phx.gen.storybook generator may guide you through these steps. ℹ️ Learn more on this topic in the sandboxing guide .","ref":"setup.html#4-make-your-components-assets-available","title":"Manual setup - 4. Make your components assets available","type":"extras"},{"doc":"Then you can start creating some content for your storybook. Storybook can contain different kinds of stories : component stories : to document and showcase your components across different variations. pages : to publish some UI guidelines, framework or whatever with regular HTML content. examples : to show how your components can be used and mixed in real UI pages. Stories are described as Elixir scripts ( .story.exs ) created under your :content_path folder. Feel free to organize them in sub-folders, as the hierarchy will be respected in your storybook sidebar. Here is an example of a stateless (function) component story: # storybook/components/button.story.exs defmodule MyAppWeb.Storybook.Components.Button do alias MyAppWeb.Components.Button # :live_component or :page are also available use PhoenixStorybook.Story , :component def function , do : &amp; Button . button / 1 def variations do [ % Variation { id : :default , attributes : %{ label : &quot;A button&quot; } } , % Variation { id : :green_button , attributes : %{ label : &quot;Still a button&quot; , color : :green } } ] end end","ref":"setup.html#5-create-some-content","title":"Manual setup - 5. Create some content","type":"extras"},{"doc":"","ref":"theming.html","title":"Theming components","type":"extras"},{"doc":"The storybook gives you different possibilities to apply a theme to your components. These possibilities are named strategies . The following strategies are available: sandbox class : set your theme as a CSS class, on the sandbox container, with a custom prefix assign : pass the theme as an assign to your components, with a custom key. function : call a custom module/function along with the current theme. Here is how you can use these strategies. In your storybook.ex : use PhoenixStorybook , themes_strategies : [ sandbox_class : &quot;prefix&quot; , # will set a class prefixed by `prefix-` on the sandbox container assign : :theme , function : { MyApp.ThemeHelper , :register_theme } ] If the theme_strategies key is undefined, the default sandbox_class: &quot;theme&quot; strategy is applied.","ref":"theming.html#theming-strategies","title":"Theming components - Theming Strategies","type":"extras"},{"doc":"By default, the storybook is applying a theme-* CSS class to your components/page containers and you should do as well to your application HTML body element. It will allow you to style raw HTML elements body.theme-colorful { font-family: // ... } .theme-colorful h1 { font-family: // ... font-size: // ... }","ref":"theming.html#css-theming","title":"Theming components - CSS theming","type":"extras"},{"doc":"This chapter explain how you can leverage on a Registry with the function theming strategy. An effective way to store the current theme setting so that it can be available to all your components, but still have different values for different (concurrent) users is to associate it to the current LiveView pid. Registry is a native Elixir module that handles decentralized storage, linked to specific processes. We will leverage on this to associate a theme to the current LiveView pid. First start a Registry from your Application module. defmodule PhenixStorybook.Application do def start ( _type , _args ) do children = [ { Registry , keys : :duplicate , name : ThemeRegistry } ] end end Then create a LiveView Hook that will fetch the theme from wherever it is relevant for your application: database, user session, URL params... and store it in the Registry (it's working because the Hook is running under the same pid than the Liveview). defmodule ThemeHook do def on_mount ( :default , params , _session , socket ) do theme = current_user_theme ( socket , params ) Registry . register ( ThemeRegistry , :theme , theme ) { :cont , socket } end end Mount the hook in your router . defmodule Router do live_session :default , on_mount : [ ThemeHook ] do scope &quot;/&quot; do # ... end end end Write a helper module, to be used from your components to fetch the current theme from the Registry and merge it in the component's assigns. defmodule ThemeHelpers do def set_theme ( assigns ) do pid_and_themes = Registry . lookup ( ThemeRegistry , :theme ) case find_by_pid ( pid_and_themes , self ( ) ) do { _pid , theme } -&gt; Map . put_new ( assigns , :theme , theme ) _ -&gt; raise ( &quot;theme not found in registry&quot; ) end end defp find_by_pid ( pid_and_themes , current_pid ) do Enum . find ( pid_and_themes , fn { pid , _ } -&gt; pid == current_pid end ) end end","ref":"theming.html#using-a-registry","title":"Theming components - Using a Registry","type":"extras"}]